using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices; //requirement class

namespace CShare.NET2005
{
    public partial class MainForm : Form
    {
        //SDK interface definitions.
        //==============================================================================================================
        [DllImport("apPDFEncrypt", CallingConvention = CallingConvention.StdCall)]
        public static extern int EncryptPDF(String  inFileName,String outFileName,
					                        int level,int permission,String OwnerPassword,String UserPassword,
					                        String keywords,String subject,String title,String author,String creator);

        [DllImport("apPDFEncrypt", CallingConvention = CallingConvention.StdCall)]
        public static extern int IsEncryptPDF(String inFileName);

        [DllImport("apPDFEncrypt", CallingConvention = CallingConvention.StdCall)]
        public static extern int IsPDFFormat(String inFileName);



        const int TRUE = 1;
        const int FALSE = 0;
 
        //==============================================================================================================
        public MainForm()
        {
            InitializeComponent();
        }


        //Get Permission
        //==============================================================================================================
        private int GetPermission(int Print, int Copy, int Modify)
        {
            int permission = 0;

            if (Print == TRUE)
                permission += 1;
            if (Copy == TRUE)
                permission += 2;
            if (Modify == TRUE)
                permission += 4;

            return permission;
        }


        //example
        //==============================================================================================================
        private void btnDemo1_Click(object sender, EventArgs e)
        {
	        int encyptlevel,permission=0;
            String srcpath = "test.pdf";
            String despath;



            if (IsPDFFormat(srcpath) == TRUE && IsEncryptPDF(srcpath) == FALSE)
	        {

		        //rc4 40 bit encrypt
                despath = "test_rc4_40.pdf";
		        encyptlevel=1;
		        //limit print,permission copy,permission modify
                permission = GetPermission(FALSE, TRUE, TRUE);
		        EncryptPDF(srcpath,despath,
						        encyptlevel,permission,"owner","user",
						        "keywords","subject","title","author","creator");

		        //rc4 128 bit encrypt
                despath = "test_rc4_128.pdf";
		        encyptlevel=2;
		        //limit print,limit copy,permission modify
                permission = GetPermission(FALSE, FALSE, TRUE);
		        EncryptPDF(srcpath,despath,
						        encyptlevel,permission,"owner","",
						        "keywords","subject","title","author","creator");

		        //aes 128 bit encrypt
                despath = "test_aes_128.pdf";
                encyptlevel = 3;
		        //limit print,limit copy,limit modify
                permission = GetPermission(FALSE, FALSE, FALSE);
		        EncryptPDF(srcpath,despath,
						        encyptlevel,permission,"owner","user",
						        "keywords","subject","title","author","creator");

	        }

	        return ;


        }


    }
}