unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus;
//----------------------------------------------------------------------------------------

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    //{ Private declarations }
  public
    //{ Public declarations }
  end;

  EncryptPDF = function(inFileName:PChar; outFileName:PChar;
					              level:Longint; permission:Longint; OwnerPassword:PChar; UserPassword:PChar;
					              keywords:PChar; subject:PChar; title:PChar; author:PChar; creator:PChar ): Longint	; stdcall	;

  IsEncryptPDF = function (inFileName:PChar): Longint	; stdcall	;
  IsPDFFormat = function (inFileName:PChar): Longint	; stdcall	;


//----------------------------------------------------------------------------------------


//----------------------------------------------------------------------------------------

var
  Form1: TForm1;

  pEncryptPDF			:EncryptPDF;
  pIsEncryptPDF		:IsEncryptPDF;
  pIsPDFFormat		:IsPDFFormat;

  g_hEncryptpdf : HMODULE	;

implementation

{$R *.dfm}


//----------------------------------------------------------------------------------------

function FreeapWDll() : Boolean;
begin
	if(g_hEncryptpdf = 0) then begin
		FreeapWDll:=False;
    Exit;
  end;
	FreeLibrary(g_hEncryptpdf);
	g_hEncryptpdf:=0;
  Result:=True;
end;
//----------------------------------------------------------------------------------------

function  LoadapWDll() :Boolean ;
var
  path:PAnsiChar ;
  proc :FARPROC ;
label
  Failer;

begin
  path := 'apPDFEncrypt.dll';
  g_hEncryptpdf :=LoadLibrary(path);
	if(g_hEncryptpdf=0) then
		goto Failer;

	proc:=GetProcAddress(g_hEncryptpdf,'_EncryptPDF@44');
	if(proc=nil)then
		goto Failer;
  pEncryptPDF:=proc ;

	proc:=GetProcAddress(g_hEncryptpdf,'_IsEncryptPDF@4');
	if(proc=nil)then
		goto Failer;
  pIsEncryptPDF:=proc ;

  proc:=GetProcAddress(g_hEncryptpdf,'_IsPDFFormat@4');
	if(proc=nil)then
		goto Failer;
  pIsPDFFormat:=proc ;

  Result:=True;
  Exit;

  Failer:
    FreeapWDll();
    Result:=False;
end;

//----------------------------------------------------------------------------------------
function GetPermission(Print: Boolean; Copy: Boolean; Modify: Boolean) : Longint;
var
	permission: Longint;
begin

  permission := 0;
	if Print  then
		permission := permission+1;

	if Copy   then
		permission := permission+2;

	if Modify  then
		permission := permission+4;

	Result:= permission;

end;

//----------------------------------------------------------------------------------------

procedure TForm1.Button1Click(Sender: TObject);
var
  encyptlevel : Longint;
  permission : Longint;
	srcpath : PChar;
	despath : PChar;


begin

  srcpath := 'test.pdf';

	if  LoadapWDll() = False then
		exit;

	if (pIsPDFFormat(srcpath)=1) and (pIsEncryptPDF(srcpath)=0)  then
	begin

		//rc4 40 bit encrypt
		despath := 'test_rc4_40.pdf';
		encyptlevel:=1;
		//limit print,permission copy,permission modify
		permission:=GetPermission(False,True,True);
		pEncryptPDF(srcpath,despath,
						encyptlevel,permission,'owner','user',
						'keywords','subject','title','author','creator');

		//rc4 128 bit encrypt
		despath := 'test_rc4_128.pdf';
		encyptlevel:=2;
		//limit print,limit copy,permission modify
		permission:=GetPermission(False,False,True);
		pEncryptPDF(srcpath,despath,
						encyptlevel,permission,'owner',nil,
						'keywords','subject','title','author','creator');

		//aes 128 bit encrypt
		despath := 'test_aes_128.pdf';
		encyptlevel:=3;
		//limit print,limit copy,limit modify
		permission:=GetPermission(False,False,False);
		pEncryptPDF(srcpath,despath,
						encyptlevel,permission,'owner','user',
						'keywords','subject','title','author','creator');

	end;

	FreeapWDll();
  
end;

end.
