

#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 


typedef long  (__stdcall *EncryptPDF)(char * inFileName,char *outFileName,
					long level,long permission,char *OwnerPassword,char *UserPassword,
					char *keywords,char *subject,char *title,char *author,char *creator );
typedef BOOL (__stdcall *IsEncryptPDF)(char * inFileName);
typedef BOOL (__stdcall *IsPDFFormat)(char * inFileName);


HMODULE				g_hEncryptpdf=NULL;

EncryptPDF			pEncryptPDF;
IsEncryptPDF		pIsEncryptPDF;
IsPDFFormat			pIsPDFFormat;

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadEncryptPDF(void);
void	FreeEncryptPDF();



BOOL LoadEncryptPDF()
{
	char path[_MAX_PATH];
	GetModulePath(path,"apPDFEncrypt.dll");
	g_hEncryptpdf=LoadLibrary(path);
	if(g_hEncryptpdf==NULL)
		goto Failer;

	pEncryptPDF=(EncryptPDF)GetProcAddress(g_hEncryptpdf,"_EncryptPDF@44");
	if(pEncryptPDF==NULL)
		goto Failer;

	pIsEncryptPDF=(IsEncryptPDF)GetProcAddress(g_hEncryptpdf,"_IsEncryptPDF@4");
	if(pIsEncryptPDF==NULL)
		goto Failer;

	pIsPDFFormat=(IsPDFFormat)GetProcAddress(g_hEncryptpdf,"_IsPDFFormat@4");
	if(pIsPDFFormat==NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeEncryptPDF(); 
	return FALSE;

}

void FreeEncryptPDF()
{
	if(g_hEncryptpdf==NULL)
		return ;
	FreeLibrary(g_hEncryptpdf);
	g_hEncryptpdf=NULL;
}


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}



long GetPermission(BOOL Print,BOOL Copy,BOOL Modify)
{
	long permission=0;

	if(Print)
		permission+=1;
	if(Copy)
		permission+=2;
	if(Modify)
		permission+=4;

	return permission;
}

main()
{
	int encyptlevel,permission=0;
	char srcpath[_MAX_PATH] = "\0";
	char despath[_MAX_PATH] = "\0";

	GetModulePath(srcpath,"test.pdf");

	if(LoadEncryptPDF()==FALSE)
		return FALSE;

	if(pIsPDFFormat(srcpath)==TRUE && pIsEncryptPDF(srcpath)==FALSE)
	{

		//rc4 40 bit encrypt
		GetModulePath(despath,"test_rc4_40.pdf");
		encyptlevel=1;
		//limit print,permission copy,permission modify
		permission=GetPermission(FALSE,TRUE,TRUE);
		pEncryptPDF(srcpath,despath,
						encyptlevel,permission,"owner","user",
						"keywords","subject","title","author","creator");

		//rc4 128 bit encrypt
		GetModulePath(despath,"test_rc4_128.pdf");
		encyptlevel=2;
		//limit print,limit copy,permission modify
		permission=GetPermission(FALSE,FALSE,TRUE);
		pEncryptPDF(srcpath,despath,
						encyptlevel,permission,"owner",NULL,
						"keywords","subject","title","author","creator");

		//aes 128 bit encrypt
		GetModulePath(despath,"test_aes_128.pdf");
		encyptlevel=3;
		//limit print,limit copy,limit modify
		permission=GetPermission(FALSE,FALSE,FALSE);
		pEncryptPDF(srcpath,despath,
						encyptlevel,permission,"owner","user",
						"keywords","subject","title","author","creator");

	}

	FreeEncryptPDF();

	return TRUE;
}