<%@ Page Language="c#" debug="true" %>
<%@ Import Namespace = "System.Runtime.InteropServices" %>
<script language="c#" runat="server">


	//SDK interface definitions.
	//==============================================================================================================                                         
	[DllImport("apPDFEncrypt", CallingConvention = CallingConvention.StdCall)]
	public static extern int EncryptPDF(String  inFileName,String outFileName,
				                        int level,int permission,String OwnerPassword,String UserPassword,
				                        String keywords,String subject,String title,String author,String creator);
	
	[DllImport("apPDFEncrypt", CallingConvention = CallingConvention.StdCall)]
	public static extern int IsEncryptPDF(String inFileName);
	
	[DllImport("apPDFEncrypt", CallingConvention = CallingConvention.StdCall)]
	public static extern int IsPDFFormat(String inFileName);
	                                  
 
	//Definitions of const
	//==============================================================================================================
    const int TRUE = 1;
    const int FALSE = 0;
  

    //Get Permission
    //==============================================================================================================
    protected int GetPermission(int Print, int Copy, int Modify)
    {
        int permission = 0;

        if (Print == TRUE)
            permission += 1;
        if (Copy == TRUE)
            permission += 2;
        if (Modify == TRUE)
            permission += 4;

        return permission;
    }


    //example
    //==============================================================================================================
    protected void Page_Load(Object Src, EventArgs E) 
    {
        int encyptlevel,permission=0;
        String srcpath = "d:/test/test.pdf";
        String despath;


		Response.Write( "PDF Encrypt begin ...<br>" );   
        if (IsPDFFormat(srcpath) == TRUE && IsEncryptPDF(srcpath) == FALSE)
        {

	        //rc4 40 bit encrypt
            despath = "d:/test/test_rc4_40.pdf";
	        encyptlevel=1;
	        //limit print,permission copy,permission modify
            permission = GetPermission(FALSE, TRUE, TRUE);
	        EncryptPDF(srcpath,despath,
					        encyptlevel,permission,"owner","user",
					        "keywords","subject","title","author","creator");

	        //rc4 128 bit encrypt
            despath = "d:/test/test_rc4_128.pdf";
	        encyptlevel=2;
	        //limit print,limit copy,permission modify
            permission = GetPermission(FALSE, FALSE, TRUE);
	        EncryptPDF(srcpath,despath,
					        encyptlevel,permission,"owner","",
					        "keywords","subject","title","author","creator");

	        //aes 128 bit encrypt
            despath = "d:/test/test_aes_128.pdf";
            encyptlevel = 3;
	        //limit print,limit copy,limit modify
            permission = GetPermission(FALSE, FALSE, FALSE);
	        EncryptPDF(srcpath,despath,
					        encyptlevel,permission,"owner","user",
					        "keywords","subject","title","author","creator");

        }
		Response.Write( "PDF Encrypt end.<br>" );   

        return ;


    } 
    
    
      
</script> 